Hot News aus dem CAD.de-Newsletter:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  SolidWorks
  PDF Makro farbig schwarz/weis

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   PDF Makro farbig schwarz/weis (337 mal gelesen)
klaus0815
Mitglied


Sehen Sie sich das Profil von klaus0815 an!   Senden Sie eine Private Message an klaus0815  Schreiben Sie einen Gästebucheintrag für klaus0815

Beiträge: 2
Registriert: 28.12.2009

erstellt am: 09. Jul. 2018 10:23    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities


2018-07-0909_43_04-Systemoptionen-PDF.jpg

 
Hallo an alle Interessierten,

Ich habe bereits seit längerem ein PDF Makro in Benutzung welches prüft ob ein PDF vorhanden ist und ob dies Schreibgeschützt ist wenn man es überschreiben möchte.

(Leichte Modifikation des Makor von Andreas Bacher)

Code:
' ******************************************************************************
' C:\DOKUME~1\ast06\LOKALE~1\Temp\swx2140\Macro1.swb - macro recorded on 14/04/04 by Andreas Bacher
' ******************************************************************************

Dim Value As Integer
Dim swApp As Object
Dim Part As Object
Dim boolstatus As Boolean
Dim longstatus As Long, longwarnings As Long
Dim FeatureData As Object
Dim Feature As Object
Dim Component As Object
Dim saveFileName As String


Sub main()
' **
Set swApp = Application.SldWorks


Set Part = swApp.ActiveDoc
swApp.ActiveDoc.ActiveView.FrameState = 1
swApp.ActiveDoc.ActiveView.FrameState = 1
Part.EditSketch


If (swApp.ActiveDoc.GetPathName = "") Then          'Abfrage ob Name vergeben wurde
    MsgBox ("Bitte zuerst Zeichnung speichern!")
    Exit Sub
End If

'swApp.SetUserPreferenceToggle swUserPreferenceToggle_e.swPDFExportInColor, False 'PDF in SW

saveFileName = Left(swApp.ActiveDoc.GetPathName, Len(swApp.ActiveDoc.GetPathName) - 7) + ".PDF" ' Speichern als PDF-Datei
If Part.SaveAs2(saveFileName, 0, True, True) = 0 Then
'MsgBox ("PDF erstellt")
Else
  MsgBox ("PDF scheint schreibgeschützt zu sein")
End If

End Sub


Es geht mir um die Auskommentierte Zeile

Code:
'swApp.SetUserPreferenceToggle swUserPreferenceToggle_e.swPDFExportInColor, False 'PDF in SW

Hier möchte ich das das PDF in schwarz/weiß erzeugt wird, aber ich bekomme immer Laufzeitfehler 424 und weis nicht direkt was ich dagegen tun kann.
Die Zeile habe ich mir einfach aus einem selbst aufgezeichnet Makro entnommen, bei dem ich bei den Einstellungen zu PDF den Haken entferne.

Code:
Dim swApp As Object

Dim Part As Object
Dim boolstatus As Boolean
Dim longstatus As Long, longwarnings As Long

Sub main()

Set swApp = Application.SldWorks

Set Part = swApp.ActiveDoc
swApp.SetUserPreferenceToggle swUserPreferenceToggle_e.swPDFExportInColor, False
End Sub



Weis einer wie Ich den Code anpassen kann.
Bin nicht sehr erfahren, aber man lernt ja immer dazu.

Gruß Klaus

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

HenryV
Mitglied
Konstrukteur, Engineering


Sehen Sie sich das Profil von HenryV an!   Senden Sie eine Private Message an HenryV  Schreiben Sie einen Gästebucheintrag für HenryV

Beiträge: 645
Registriert: 18.05.2005

SolidWorks 2018 x64 SP4.0
Dell T3600 Workstation
Intel XENON 6x3.2 GHz
NVIDIA Quadro 4000 2 GB
16GB RAM
2x Dell U2412M, 24" TFT
Windows 7 Professional x64 SP1
Microsoft Office Pro 2010 SP2
Kaspersky Anti-Virus 10.2.4.674
Microsoft VB 2010 Express
SpacePilot von 3Dconnexion

erstellt am: 09. Jul. 2018 11:30    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für klaus0815 10 Unities + Antwort hilfreich

Hallo Klaus

Das liegt an den fehlenden Referenzen.
Im VBA-Editor musst du unter Tools->References... die Haken bei SOLIDWORKS 201X Commands type library
und  SOLIDWORKS 201X Constant type library setzten.

Gruss Andreas

------------------
21 ist nur die halbe Antwort.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Spirou85
Mitglied
Konstruktuer und CAD-Betreuer


Sehen Sie sich das Profil von Spirou85 an!   Senden Sie eine Private Message an Spirou85  Schreiben Sie einen Gästebucheintrag für Spirou85

Beiträge: 38
Registriert: 01.12.2014

HP ZBook 17 G3
i7-6820 2,7 GHz - 32GB Ram
NVIDIA Quadro M4000M
Windows 10 Pro 64Bit Version 1803
Build 17134.285
SWX2017-64Bit-SP5.0
MaxxDB 2017 SP1.65
DraftSight 2018 x64 SP2
3DCONNEXION SpaceMouse Enterprise mit CadMouse

erstellt am: 09. Jul. 2018 11:33    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für klaus0815 10 Unities + Antwort hilfreich

Hallo Klaus,

bei mir sieht die Code-Zeile so aus:

Code:
swApp.SetUserPreferenceToggle swPDFExportInColor, False    'PDF nicht in Farbe exportieren

Und damit funktioniert es.

------------------
Viele Grüße aus Brackenheim

Lars Pauly

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

klaus0815
Mitglied


Sehen Sie sich das Profil von klaus0815 an!   Senden Sie eine Private Message an klaus0815  Schreiben Sie einen Gästebucheintrag für klaus0815

Beiträge: 2
Registriert: 28.12.2009

erstellt am: 09. Jul. 2018 12:51    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities


2018-07-0912_41_59-Verweise-Export_pdf_dxf.jpg

 
JAA!!

Das ist es Danke! Darauf bin ich nicht gekommen!

Für alle die es wissen möchten hier die Einstellungen.

Und hier der Code zum PDF in farbe

Code:
' ******************************************************************************
' C:\DOKUME~1\ast06\LOKALE~1\Temp\swx2140\Macro1.swb - macro recorded on 09/07/18 by Marco Hörnig
' ******************************************************************************

Dim Value As Integer
Dim swApp As Object
Dim Part As Object
Dim boolstatus As Boolean
Dim longstatus As Long, longwarnings As Long
Dim FeatureData As Object
Dim Feature As Object
Dim Component As Object
Dim saveFileName As String
Dim pdfColor As Boolean

Sub main()
' **
Set swApp = Application.SldWorks

pdfColor = swApp.GetUserPreferenceToggle(swUserPreferenceToggle_e.swPDFExportInColor) 'Fragt akutellen Status zu PDF farbig oder schwarz/weis ab
Set Part = swApp.ActiveDoc

swApp.ActiveDoc.ActiveView.FrameState = 1
swApp.ActiveDoc.ActiveView.FrameState = 1
Part.EditSketch

If (swApp.ActiveDoc.GetPathName = "") Then          'Abfrage ob Name vergeben wurde
    MsgBox ("Bitte zuerst Zeichnung speichern!")
    Exit Sub
End If
swApp.SetUserPreferenceToggle swUserPreferenceToggle_e.swPDFExportInColor, True 'True =frabig, False =schwarz/weiß
saveFileName = Left(swApp.ActiveDoc.GetPathName, Len(swApp.ActiveDoc.GetPathName) - 7) + ".PDF" ' Speichern als PDF-Datei
If Part.SaveAs2(saveFileName, 0, True, True) = 0 Then
'MsgBox ("PDF erstellt")
Else
   MsgBox ("PDF scheint schreibgeschützt zu sein")
End If
swApp.SetUserPreferenceToggle swUserPreferenceToggle_e.swPDFExportInColor, pdfColor 'stellt alte Einstellung von PDF farbig oder schwarz/weis wieder her
'MsgBox pdfColor, , "PDF scheint schreibgeschützt zu sein"

End Sub


[Diese Nachricht wurde von klaus0815 am 09. Jul. 2018 editiert.]

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2018 CAD.de | Impressum | Datenschutz